PROGRAM_NAME='Mistubishi_G50a_MAIN'
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/05/2006  AT: 09:00:25        *)
(***********************************************************)
(*  FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 08/19/2009  AT: 14:05:05                *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*  FILE REVISION: Rev 1                                   *)
(*  REVISION DATE: 08/19/2009  AT: 14:01:02                *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

dvG50a		=	0:3:0	// master port for communication to G50a via TCP/IP
vdvG50A1	=	33001:1:0	// Virtual device for module communication stores levels and channels per hvac unit/group.
vdvG50A2	=	33001:2:0	// Virtual device for module communication
// could be up to 50 vitual device ports MAXGRP should be updated to reflect this number
(*
vdvG50A3	=	33001:3:0	// Virtual device for module communication
vdvG50A4	=	33001:4:0	// Virtual device for module communication
vdvG50A5	=	33001:5:0	// Virtual device for module communication
vdvG50A6	=	33001:6:0	// Virtual device for module communication
vdvG50A7	=	33001:7:0	// Virtual device for module communication
vdvG50A8	=	33001:8:0	// Virtual device for module communication
vdvG50A9	=	33001:9:0	// Virtual device for module communication
vdvG50A10	=	33001:10:0	// Virtual device for module communication
*)
dvTP        =	10001:1:0	// port 1 for touch panel input
dvTP2        =	10001:2:0	// port 1 for touch panel input
// during testing 2 groups were used and data was sent to 2 ports on one touch panel set in a dev array

////////// VERY IMPORTANT PLEASE READ THIS /////////////////////////////
///////////////////////////////////////////////////////////////////////////
// each hvac unit has a virtual port assigned to it so channels and levels can be used //
// level 1 is the set point, level 3 is the inlet or actual temp, these can be adjusted    //
// however there are only 8 levels by default on virtual devices unless defined by   //
// the programmer. Other channels are defined in the Main code. Also, exposed are //
// the timeline for communication with the G50, which provide feedback on all        //
// attached units currently once a minute. channel 255 "device communicating"        //
// only tracks on virtual port 1


(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

MAXGRP = 2	//10		// ENTER MAX NUMBER OF GROUPS HERE // MAX NUMBER SUPPORTED IS 50

TL1 = 1
                // HVAC Channels and Levels

// HVAC Channels
HVAC_SETP_UP	          	= 140   // Momentary: Increment cooling set point
HVAC_SETP_DN	           	= 141   // Momentary: Decrement cooling set point

HVAC_FILTER_RESET		= 210   // Momentary: Hold channel on virtual device for 10 seconds to reset
HVAC_FILTER_FB			= 210   // Feedback: HVAC Filter needs to be changed and reset
HVAC_FAN	            		= 214   // Momentary: Set fan state to on
HVAC_FAN_FB  		       	= 214   // Feedback:  Fan state on feedback
HVAC_AUTO              		= 219   // Momentary: Set HVAC state to automatic
HVAC_AUTO_FB           		= 219   // Feedback:  HVAC auto feedback
HVAC_COOL        	      		= 220   // Momentary: Set HVAC state to cooling
HVAC_COOL_FB           		= 220   // Feedback:  HVAC cool feedback
HVAC_HEAT              		= 221   // Momentary: Set HVAC state to heating
HVAC_HEAT_FB           		= 221   // Feedback:  HVAC heat feedback
HVAC_DRY				= 231   // Momentary: Set HVAC State to Dry
HVAC_DRY_FB			= 231   // Feedback: HVAC Dry feedback
HVAC_FS_LOW              		= 240   // Momentary: Set HVAC FAN SPEED TO LOW
HVAC_FS_MID1           		= 241   // Momentary: Set HVAC FAN SPEED TO MID1
HVAC_FS_MID2			= 242   // Momentary: Set HVAC FAN SPEED TO MID2
HVAC_FS_HIGH			= 243   // Momentary: Set HVAC FAN SPEED TO HIGH
HVAC_AIR_HORZ			= 244  // Momentary: set HVAC air direction to horizaontal
HVAC_AIR_MID1			= 245  // Momentary: set HVAC air direction to MID1
HVAC_AIR_MID2			= 246  // Momentary: set HVAC air direction to MID2
HVAC_AIR_VERT			= 247  // Momentary: set HVAC air direction to VERTICAL
HVAC_AIR_SWING		= 248  // Momentary: set HVAC air direction to SWING
HVAC_DRIVE_ON			= 249  // Momentary set HVAC Drive on
HVAC_DRIVE_OFF    		= 250   // Momentary set HVAC Drive off
HVAC_DRIVE_FB    		= 250   // Feedback: HVAC drive state feedback


DEVICE_COMMUNICATING   = 255   // Channel Feedback:  Device online event only on while communicating on
							    // virtual device port 1
DATA_INITIALIZED       	= 252   // Feedback:  Data initialized event; pulses each timedata is received

// HVAC Levels
HVAC_SETP_LVL          		= 1    // Level: Cooling set point, range is n..m degrees F or C
INDOOR_TEMP_LVL        	= 3    // Level: Indoor temperature, range is n..m degrees F or C

INTEGER MAXTEMP = 30	// XML ONLY GIVES CELCIUS
INTEGER MINTEMP = 17

INTEGER CUR_ZONE_TEXT_ADDR = 1
INTEGER DRV_STATE_TEXT_ADDR = 2
INTEGER CUR_MODE_TEXT_ADDR =3
INTEGER SET_POINT_TEXT_ADDR = 4
INTEGER AIR_DIR_TEXT_ADDR = 5
INTEGER FAN_SPEED_TEXT_ADDR = 6
INTEGER CUR_TEMP_TEXT_ADDR = 7

CHAR HVAC_DRIVE[][3] = {'OFF','ON'}
CHAR HVAC_MODE[][8] = {'COOL','DRY','FAN','HEAT','AUTO'}
CHAR HVAC_AIRD[][15] = {'HORIZONTAL','MID1','MID2','VERTICAL','SWING'}
CHAR HVAC_FAN_STATE[][8] = {'LOW','MID1','MID2','HIGH'}

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

STRUCT _sHVAC_PROPERTIES	// PROPERTIES PER GROUP WHICH IS REALLY FOR EACH ZONE IDENTIFIED IN G50
{
    INTEGER DRV	//DRIVE 0 = OFF 1 = ON
    INTEGER MODE	// MODE 1=COOL,2=DRY,3=FAN,4=HEAT,5=AUTO
    INTEGER SETP	// CURRENTLY 17 TO 30 CELCIUS UPDATED IN LEVEL EVENT 1 ON VIRTUAL DEVICE
    INTEGER Air	// AirDirection, 1=HORIZONTAL,1=MID1,3=MID2,4=VERTICAL,5=SWING
    INTEGER FAN	// FanSpeed,1=LOW,2=MID1,3=MID2,4=HIGH
    INTEGER TEMP	// INLET TEMP WHICH IS ROOM TEMP UPDATED IN LEVEL EVENT 3 ON VIRTUAL DEVICE
    INTEGER FILTR	// FILTER SETTING 0 = OK, 1 = NEEDS CHANGING,
}

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

DEV vdvG50a[] = 
{			vdvG50A1,vdvG50A2}//,vdvG50A3,vdvG50A4,vdvG50A5,
			//vdvG50A6,vdvG50A7,vdvG50A8,vdvG50A9,vdvG50A10
//}

DEV DEV_TP_GRP[] = {dvTP,dvTP2}

IP_ADDRESS_STRUCT IP_INFO

CHAR DEV_IP_ADDR[20]

INTEGER GRP_NUM	// GROUP ADDRESS 1 - 50 SET IN INITIAL SYSTEM DESIGN IN G-50 WEB PAGE

_sHVAC_PROPERTIES myHVAC[MAXGRP]	

CHAR cSETP[2]	//FEEDBACK SENT FROM REAL DEVICE AS A STRING ALSO
CHAR cITEMP[2]	//FEEDBACK SENT FROM REAL DEVICE AS A STRING ALSO
INTEGER bCELCIUS	// USED TO TRACK IF DISPLAY IS CELCIUS OR FAHRENHEIT
INTEGER nTEMP_SETPOINT[MAXGRP]	// TEMP SET POINT FOR CONVERTING
INTEGER nTMP_INLET[MAXGRP]	// TEMP INLET FOR CONVERTING

CHAR RETURN_STRING[1000]

// VARIABLES TO TRACK WHICH PROPERTIES ARE BEING ADJUSTED ON WHICH UNITS
// FOR VISUAL FEEDBACK UNTIL INFORMATION IS SENT TO THE UNIT USING 'SETHVAC-' COMMAND
INTEGER nFLASH
INTEGER nMODEadj
INTEGER nAIRadj
INTEGER nFANadj
INTEGER nDRVadj

LONG lTL_TIME[1] = {60000}	// RUNS TO UPDATE GROUPS EVERYMINUTE
LONG lTIMER_GET	// USED FOR GETTING TIMER FOR PAUSED OPERATION

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)

DEFINE_FUNCTION fnDISPLAY_GROUP()	// DISPLAY UNITS ON TOUCH PANEL. MUST UPDATE ONE TIME AT LEAST
{
    SEND_COMMAND DEV_TP_GRP[GRP_NUM],"'^TXT-',ITOA(CUR_ZONE_TEXT_ADDR),',0,',ITOA(GRP_NUM)"
    SEND_COMMAND DEV_TP_GRP[GRP_NUM],"'^TXT-',ITOA(DRV_STATE_TEXT_ADDR),',0,',HVAC_DRIVE[myHVAC[GRP_NUM].DRV]"
    SEND_COMMAND DEV_TP_GRP[GRP_NUM],"'^TXT-',ITOA(CUR_MODE_TEXT_ADDR),',0,',HVAC_MODE[myHVAC[GRP_NUM].MODE]"
    SEND_COMMAND DEV_TP_GRP[GRP_NUM],"'^TXT-',ITOA(AIR_DIR_TEXT_ADDR),',0,',HVAC_AIRD[myHVAC[GRP_NUM].AIR]"
    SEND_COMMAND DEV_TP_GRP[GRP_NUM],"'^TXT-',ITOA(FAN_SPEED_TEXT_ADDR),',0,',HVAC_FAN_STATE[myHVAC[GRP_NUM].FAN]"
    SEND_COMMAND DEV_TP_GRP[GRP_NUM],"'^TXT-',ITOA(SET_POINT_TEXT_ADDR),',0,',ITOA(nTEMP_SETPOINT[GRP_NUM])"
    SEND_COMMAND DEV_TP_GRP[GRP_NUM],"'^TXT-',ITOA(CUR_TEMP_TEXT_ADDR),',0,',ITOA(nTMP_INLET[GRP_NUM])"
}
// this is an example and may need to be adjusted but is here for the programmer
DEFINE_FUNCTION INTEGER fnTEMP_DISPLAY(INTEGER nTEMP)
{
    IF((nTEMP * 9) % 5 > 2)
    {
	nTEMP = nTEMP * 9 / 5 + 33
    }
    ELSE
	nTEMP = nTEMP * 9 / 5 +32
    RETURN nTEMP
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START
// VIRTUAL PORTS CREATED FOR MAX NUMBER OF UNITS. 10 ARE SET HERE GB-50 SUPPORTS 50 MAX ON A 1:TO 1 RATIO
SET_VIRTUAL_PORT_COUNT(vdvG50A1,MAXGRP)
GRP_NUM = 1	// should not be left at zero since the unit has no zero groups
TIMELINE_CREATE(TL1,lTL_TIME,1,TIMELINE_ABSOLUTE,TIMELINE_REPEAT)	// STARTS TO UPDATE GROUPS

#WARN 'ENTER G50a IP ADDRESS HERE'
DEV_IP_ADDR = '192.168.0.20'	// this should be set for the ip of the ag150 or gb-50

SEND_COMMAND vdvG50A1,"'PROPERTY-IP:',DEV_IP_ADDR"
WAIT 20
SEND_COMMAND vdvG50A1,"'PROPERTY-GROUPS:',ITOA(MAXGRP)"

// comm module definition goes here
DEFINE_MODULE 'Mitsubishi_G50a_COMM' mdl1 (vdvG50a,dvG50a)

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT
// SELECT ZONE OR GROUP WHICH SHOULD BE IN A KEYP- COMMAND
// or some other way to populate grp_NUM
BUTTON_EVENT[dvTP,21]
BUTTON_EVENT[dvTP,22]
BUTTON_EVENT[dvTP,23]
BUTTON_EVENT[dvTP,24]
BUTTON_EVENT[dvTP,25]
BUTTON_EVENT[dvTP,26]
BUTTON_EVENT[dvTP,27]
BUTTON_EVENT[dvTP,28]
BUTTON_EVENT[dvTP,29]
BUTTON_EVENT[dvTP,30]
BUTTON_EVENT[dvTP,31]
{                             
    PUSH:
    {
	GRP_NUM = BUTTON.INPUT.CHANNEL - 20
	fnDISPLAY_GROUP()
    }
}
// SELECT MODE FOR UNIT VIA TOUCH PANEL
// nMODEadj was for TEMP FB (FLASHING) THAT CHANGES WERE BEING MADE
BUTTON_EVENT[dvTP,HVAC_COOL]
BUTTON_EVENT[dvTP,HVAC_HEAT]
BUTTON_EVENT[dvTP,HVAC_DRY]
BUTTON_EVENT[dvTP,HVAC_FAN]
BUTTON_EVENT[dvTP,HVAC_AUTO]
{
    PUSH:
    {
	SWITCH (BUTTON.INPUT.CHANNEL)
	{
	    CASE HVAC_COOL:
	    {
		myHVAC[GRP_NUM].MODE = 1
		nMODEadj = 1
	    }
	    CASE HVAC_HEAT:
	    {
		myHVAC[GRP_NUM].MODE = 4
		nMODEadj = 4
	    }
	    CASE HVAC_DRY:
	    {
		myHVAC[GRP_NUM].MODE = 2
		nMODEadj = 2
	    }
	    CASE HVAC_FAN:
	    {
		myHVAC[GRP_NUM].MODE = 3
		nMODEadj = 3
	    }
	    CASE HVAC_AUTO:
	    {
		myHVAC[GRP_NUM].MODE = 5
		nMODEadj = 5
	    }
	}
    }
}
// SET AIR DIRECTION FOR A ZONE/GROUP
// nAIRADJ WAS FOR TEMP FB OF AIR ADJUSTMENT
BUTTON_EVENT[dvTP,HVAC_AIR_HORZ]
BUTTON_EVENT[dvTP,HVAC_AIR_MID1]
BUTTON_EVENT[dvTP,HVAC_AIR_MID2]
BUTTON_EVENT[dvTP,HVAC_AIR_VERT]
BUTTON_EVENT[dvTP,HVAC_AIR_SWING]
{
    PUSH:
    {
	PULSE[BUTTON.INPUT]
	SWITCH (BUTTON.INPUT.CHANNEL)
	{
	    CASE HVAC_AIR_HORZ:
	    {
		myHVAC[GRP_NUM].Air = 1
		nAIRADJ = 1
	    }
	    CASE HVAC_AIR_MID1:
	    {
		myHVAC[GRP_NUM].Air = 2
		nAIRADJ = 2
	    }
	    CASE HVAC_AIR_MID2:
	    {
		myHVAC[GRP_NUM].Air = 3
		nAIRADJ = 3
	    }
	    CASE HVAC_AIR_VERT:
	    {
		myHVAC[GRP_NUM].Air = 4
		nAIRADJ = 4
	    }
	    CASE HVAC_AIR_SWING:
	    {
		myHVAC[GRP_NUM].Air = 5
		nAIRADJ = 5
	    }
	}
    }
}

// SET ZONE/GROUP FAN SPEED
// nFANADJ WAS OFR TEMP FB OF FAN ADJUSTMENT
BUTTON_EVENT[dvTP,HVAC_FS_LOW]
BUTTON_EVENT[dvTP,HVAC_FS_MID1]
BUTTON_EVENT[dvTP,HVAC_FS_MID2]	// THIS BUTTON MAY NOT BE NEEDED IF THERE IS NO MID 2 FAN SPEED
BUTTON_EVENT[dvTP,HVAC_FS_HIGH]
{
    PUSH:
    {
	PULSE[BUTTON.INPUT]
	SWITCH (BUTTON.INPUT.CHANNEL)
	{
	    CASE HVAC_FS_LOW:
	    {
		myHVAC[GRP_NUM].FAN = 1
		nFANadj = 1
	    }
	    CASE HVAC_FS_MID1:
	    {
		myHVAC[GRP_NUM].FAN = 2
		nFANadj = 2
	    }
	    CASE HVAC_FS_MID2:
	    {
		myHVAC[GRP_NUM].FAN = 3
		nFANadj = 3
	    }
	    CASE HVAC_FS_HIGH:
	    {
		myHVAC[GRP_NUM].FAN = 4
		nFANadj = 4
	    }
	}
    }
}
// SET ZONE/GROUP DRIVE STATE
// nDRVADJ WAS FOR TEMP FB OF DRV ADJUSTMENT
BUTTON_EVENT[dvTP,HVAC_DRIVE_ON]
BUTTON_EVENT[dvTP,HVAC_DRIVE_OFF]
{
    PUSH:
    {
	PULSE[BUTTON.INPUT]
	SWITCH (BUTTON.INPUT.CHANNEL)
	{
	    CASE HVAC_DRIVE_ON:
	    {
		myHVAC[GRP_NUM].DRV = 1
		nDRVadj = 1
	    }
	    CASE HVAC_DRIVE_OFF:
	    {
		myHVAC[GRP_NUM].DRV = 0
		nDRVadj = 2
	    }
	}
    }
}
// IF DESIRED THE MODULE CAN RESET THE FILTER SIGN
// THIS IS USUALLY DONE THROUGH THE WEB INTERFACE
BUTTON_EVENT[dvTP,HVAC_FILTER_RESET]
{
    HOLD[100]:
    {
	IF(TIMELINE_ACTIVE(TL1))
	{
	    TIMELINE_PAUSE(TL1)
	    lTIMER_GET = TIMELINE_GET(TL1)	// GET TIMER WHEN PAUSED
	    SEND_STRING 0,'TIMELINE 1 PAUSED'
	}
	// RESETS FILTER TO OFF. MUST HAVE GROUP NUMBER SET TO APPROPRIATE VALUE
	SEND_COMMAND vdvG50a[GRP_NUM],"'FILTER-RESET'"
    }
}

// THE XML INTERFACE ONLY REPORTS CELCIUS. FAHRENHEIT IS DONE THROUGH MATH
BUTTON_EVENT[dvTP,13]	// HVAC SCALE IS CELCIUS 
{
    PUSH:
    {
	bCELCIUS = !bCELCIUS
    }
}

// USED FOR TESTING. STOPPED TIMELINE
BUTTON_EVENT[dvTP,3000]
{
    PUSH:
    {
	
	IF(TIMELINE_ACTIVE(TL1))
	{
	    PULSE[BUTTON.INPUT]
	    TIMELINE_KILL(TL1)
	    SEND_STRING 0,'TIMELINE 1 STOPPED' //TAKE THIS OUT
	}
    }
}
// USED FOR TESTING. STARTED TIMELINE
BUTTON_EVENT[dvTP,3001]
{
    PUSH:
    {
	IF(TIMELINE_ACTIVE(TL1) = 0)
	{
	    PULSE[BUTTON.INPUT]
	    TIMELINE_CREATE(TL1,lTL_TIME,1,TIMELINE_ABSOLUTE,TIMELINE_REPEAT)	// STARTS TO UPDATE GROUPS
	    SEND_STRING 0,'TIMELINE HAS BEEN STARTED' //TAKE THIS OUT
	}
    }
}

BUTTON_EVENT[dvTP,HVAC_SETP_UP]	// SET POINT UP BN
{
    PUSH:
    {
	TO[BUTTON.INPUT]
	myHVAC[GRP_NUM].SETP++
	IF(myHVAC[GRP_NUM].SETP >= MAXTEMP)	// IF SCALE IS CELCIUS AND AT THE MAX THAN KEEP IT AT MAX
	{
	    myHVAC[GRP_NUM].SETP = MAXTEMP	// SET POINT SET TO HIGHEST VALUE
	}
	nTEMP_SETPOINT[GRP_NUM] = myHVAC[GRP_NUM].SETP
	IF(bCELCIUS == 0)
	{
	    fnTEMP_DISPLAY(nTEMP_SETPOINT[GRP_NUM])
	}
	SEND_COMMAND dvTP,"'^TXT-',ITOA(SET_POINT_TEXT_ADDR),',0,',ITOA(nTEMP_SETPOINT[GRP_NUM])"
    }
    HOLD[3,REPEAT]:
    {
	myHVAC[GRP_NUM].SETP++
	IF(myHVAC[GRP_NUM].SETP >= MAXTEMP)	// IF SCALE IS CELCIUS AND AT THE MAX THAN KEEP IT AT MAX
	{
	    myHVAC[GRP_NUM].SETP = MAXTEMP	// SET POINT SET TO HIGHEST VALUE
	}
	nTEMP_SETPOINT[GRP_NUM] = myHVAC[GRP_NUM].SETP
	IF(bCELCIUS == 0)
	{
	    fnTEMP_DISPLAY(nTEMP_SETPOINT[GRP_NUM])
	}
	SEND_COMMAND dvTP,"'^TXT-',ITOA(SET_POINT_TEXT_ADDR),',0,',ITOA(nTEMP_SETPOINT[GRP_NUM])"
    }
}

BUTTON_EVENT[dvTP,HVAC_SETP_DN]	// SET POINT DN BN
{
    PUSH:
    {
	TO[BUTTON.INPUT]
	myHVAC[GRP_NUM].SETP--
	IF(myHVAC[GRP_NUM].SETP <=MINTEMP)	// IF SCALE IS CELCIUS AND AT THE BOTTOM THAN KEEP IT AT BOTTOM
	{
	    myHVAC[GRP_NUM].SETP = MINTEMP	// SET POINT SET TO LOWEST VALUE
	}
	nTEMP_SETPOINT[GRP_NUM] = myHVAC[GRP_NUM].SETP
	IF(bCELCIUS == 0)
	{
	    fnTEMP_DISPLAY(nTEMP_SETPOINT[GRP_NUM])
	}
	SEND_COMMAND dvTP,"'^TXT-',ITOA(SET_POINT_TEXT_ADDR),',0,',ITOA(nTEMP_SETPOINT[GRP_NUM])"
    }
    HOLD[3,REPEAT]:
    {
	myHVAC[GRP_NUM].SETP--
	IF(myHVAC[GRP_NUM].SETP <= MINTEMP)	// IF SCALE IS CELCIUS AND AT THE BOTTOM THAN KEEP IT AT BOTTOM
	{
	    myHVAC[GRP_NUM].SETP = MINTEMP	// SET POINT SET TO LOWEST VALUE
	}
	nTEMP_SETPOINT[GRP_NUM] = myHVAC[GRP_NUM].SETP
	IF(bCELCIUS == 0)
	{
	    fnTEMP_DISPLAY(nTEMP_SETPOINT[GRP_NUM])
	}
	SEND_COMMAND dvTP,"'^TXT-',ITOA(SET_POINT_TEXT_ADDR),',0,',ITOA(nTEMP_SETPOINT[GRP_NUM])"
    }
}
// UPDATE DATA FROM AG150/GB-50
BUTTON_EVENT[dvTP,255]
{
    PUSH:
    {
	SEND_COMMAND vdvG50a[GRP_NUM],"'?HVACGRP_ID-',ITOA(GRP_NUM)"	// REQUESTS UPDATE FOR A SPECIFIC UNIT
	PULSE[BUTTON.INPUT]
	IF(TIMELINE_ACTIVE(TL1))
	{
	    TIMELINE_PAUSE(TL1)
	    lTIMER_GET = TIMELINE_GET(TL1)	// GET TIMER WHEN PAUSED
	    SEND_STRING 0,'TIMELINE 1 PAUSED'
	}
    }
}
(************************************COMMANDS TO SET THE HVAC UNITS **************************)
// SETTINGS ARE 'SETHVAC-GRP_NUM:DRV:MODE:SETP:AIRD:FANSPEED'
// AT LEAST GRP_NUM AND ONE OTHER ITEM ARE NEEDED AND THE ORDER MUST BE MAINTAINED
// OK BTN OR SEND DATA TO AG150/GB-50
BUTTON_EVENT[dvTP,254]		// SEND TO UNIT
{
    PUSH:
    {
	IF(GRP_NUM > 0 && GRP_NUM < 51)	// CURRENT ZONE IS VALID
	{
	    PULSE[BUTTON.INPUT]
	    SEND_COMMAND vdvG50a[GRP_NUM],"'SETHVAC-',ITOA(GRP_NUM),':D-',HVAC_DRIVE[myHVAC[GRP_NUM].DRV + 1],':M-',HVAC_MODE[myHVAC[GRP_NUM].MODE],
								    ':S-',ITOA(myHVAC[GRP_NUM].SETP),':A-',HVAC_AIRD[myHVAC[GRP_NUM].AIR],':F-',HVAC_FAN_STATE[myHVAC[GRP_NUM].FAN]"	
	}
	IF(TIMELINE_ACTIVE(TL1))
	{
	    TIMELINE_PAUSE(TL1)
	    lTIMER_GET = TIMELINE_GET(TL1)	// GET TIMER WHEN PAUSED
	    SEND_STRING 0,'TIMELINE 1 PAUSED'
	}
    }
}

CHANNEL_EVENT[vdvG50a,HVAC_DRIVE_FB]	// DRIVE CHANNEL UPDATE EVENT
{
    ON:
    {
	myHVAC[GET_LAST(vdvG50a)].DRV = 1
    }
    OFF:
    {
	myHVAC[GET_LAST(vdvG50a)].DRV = 0
    }
}

CHANNEL_EVENT[vdvG50a,HVAC_COOL_FB]	// MODE CHANNEL UPDATE EVENT
CHANNEL_EVENT[vdvG50a,HVAC_HEAT_FB]
CHANNEL_EVENT[vdvG50a,HVAC_DRY_FB]
CHANNEL_EVENT[vdvG50a,HVAC_FAN_FB]
CHANNEL_EVENT[vdvG50a,HVAC_AUTO_FB]
{
    ON:
    {
	SWITCH (CHANNEL.CHANNEL)
	{
	    CASE HVAC_COOL_FB:
	    {
		myHVAC[GET_LAST(vdvG50a)].MODE = 1
	    }
	    CASE HVAC_HEAT_FB:
	    {
		myHVAC[GET_LAST(vdvG50a)].MODE = 4
	    }
	    CASE HVAC_DRY_FB:
	    {
		myHVAC[GET_LAST(vdvG50a)].MODE = 2
	    }
	    CASE HVAC_FAN_FB:
	    {
		myHVAC[GET_LAST(vdvG50a)].MODE = 3
	    }
	    CASE HVAC_AUTO_FB:
	    {
		myHVAC[GET_LAST(vdvG50a)].MODE = 5
	    }
	}
    }
}

CHANNEL_EVENT[vdvG50a,HVAC_AIR_HORZ]	// AIR DIRECTION CHANNEL UPDATE EVENT
CHANNEL_EVENT[vdvG50a,HVAC_AIR_MID1]
CHANNEL_EVENT[vdvG50a,HVAC_AIR_MID2]
CHANNEL_EVENT[vdvG50a,HVAC_AIR_VERT]
CHANNEL_EVENT[vdvG50a,HVAC_AIR_SWING]
{
    ON:
    {
	SWITCH (CHANNEL.CHANNEL)
	{
	    CASE HVAC_AIR_HORZ:
	    {
		myHVAC[GET_LAST(vdvG50a)].Air = 1
	    }
	    CASE HVAC_AIR_MID1:
	    {
		myHVAC[GET_LAST(vdvG50a)].Air = 2
	    }
	    CASE HVAC_AIR_MID2:
	    {
		myHVAC[GET_LAST(vdvG50a)].Air = 3
	    }
	    CASE HVAC_AIR_VERT:
	    {
		myHVAC[GET_LAST(vdvG50a)].Air = 4
	    }
	    CASE HVAC_AIR_SWING:
	    {
		myHVAC[GET_LAST(vdvG50a)].Air = 5
	    }
	}
    }
}

////////// FAN SPEED SET CHANNEL EVENT VIRTUAL DEVICE
CHANNEL_EVENT[vdvG50a,HVAC_FS_LOW]
CHANNEL_EVENT[vdvG50a,HVAC_FS_MID1]
CHANNEL_EVENT[vdvG50a,HVAC_FS_MID2]
CHANNEL_EVENT[vdvG50a,HVAC_FS_HIGH]
{
    ON:
    {
	SWITCH (CHANNEL.CHANNEL)
	{
	    CASE HVAC_FS_LOW:
	    {
		myHVAC[GET_LAST(vdvG50a)].FAN = 1
	    }
	    CASE HVAC_FS_MID1:
	    {
		myHVAC[GET_LAST(vdvG50a)].FAN = 2
	    }
	    CASE HVAC_FS_MID2:
	    {
		myHVAC[GET_LAST(vdvG50a)].FAN = 3
	    }
	    CASE HVAC_FS_HIGH:
	    {
		myHVAC[GET_LAST(vdvG50a)].FAN = 4
	    }
	}
    }
}

// FILTER CHANGE INDICATOR
CHANNEL_EVENT[vdvG50a,210]
{
    ON:
    {
	myHVAC[GET_LAST(vdvG50a)].FILTR = 1
    }
    OFF:
    {
	myHVAC[GET_LAST(vdvG50a)].FILTR = 0
    }
}

DATA_EVENT[vdvG50a]
{
    STRING:
    {
	LOCAL_VAR INTEGER IDX
	LOCAL_VAR INTEGER nHVAC_ZONE
	IDX = GET_LAST(vdvG50a)
	RETURN_STRING = "RETURN_STRING,DATA.TEXT"
	nMODEadj = 0
	nAIRADJ = 0
	nFANadj = 0
	nDRVadj = 0
	SEND_COMMAND dvTP,"'^TXT-8,0,'"
	IF(lTIMER_GET == TIMELINE_GET(TL1))	// GET TIMER WHEN PAUSED)
	    {
		TIMELINE_RESTART(TL1)
		SEND_STRING 0,'TIMELINE 1 RUNNING'
	    }	// This is an example of the string sent from the module updating each group/zone settings
	IF(FIND_STRING(RETURN_STRING,'HVACSET-',1))	// FEEDBACK STRING FROM UPDATE COMMAND 
	{
	    REMOVE_STRING(RETURN_STRING,'-',1)
	    nHVAC_ZONE = ATOI(LEFT_STRING(RETURN_STRING,FIND_STRING(RETURN_STRING,':',1) - 1))
	    SEND_COMMAND DEV_TP_GRP[nHVAC_ZONE],"'^TXT-',ITOA(CUR_ZONE_TEXT_ADDR),',0,',LEFT_STRING(RETURN_STRING,FIND_STRING(RETURN_STRING,':',1) - 1)"
	    IF(FIND_STRING(RETURN_STRING,'D-',1))
	    {
		REMOVE_STRING(RETURN_STRING,'D-',1)
		SEND_COMMAND DEV_TP_GRP[nHVAC_ZONE],"'^TXT-',ITOA(DRV_STATE_TEXT_ADDR),',0,',LEFT_STRING(RETURN_STRING,FIND_STRING(RETURN_STRING,':',1) -1)"
	    }
	    IF(FIND_STRING(RETURN_STRING,'M-',1))
	    {
		REMOVE_STRING(RETURN_STRING,'-',1)
		SEND_COMMAND DEV_TP_GRP[nHVAC_ZONE],"'^TXT-',ITOA(CUR_MODE_TEXT_ADDR),',0,',LEFT_STRING(RETURN_STRING,FIND_STRING(RETURN_STRING,':',1) -1)"
	    }
	    IF(FIND_STRING(RETURN_STRING,'S-',1))	// HANDLED IN LEVEL EVENT
	    {
		REMOVE_STRING(RETURN_STRING,'-',1)
		cSETP = LEFT_STRING(RETURN_STRING,FIND_STRING(RETURN_STRING,':',1) -1)	// TEXT BUTTON UPDATED FROM LEVEL EVENT
	    }
	    IF(FIND_STRING(RETURN_STRING,'A-',1))
	    {
		REMOVE_STRING(RETURN_STRING,'-',1)
		SEND_COMMAND DEV_TP_GRP[nHVAC_ZONE],"'^TXT-',ITOA(AIR_DIR_TEXT_ADDR),',0,',LEFT_STRING(RETURN_STRING,FIND_STRING(RETURN_STRING,':',1) -1)"
	    }
	    IF(FIND_STRING(RETURN_STRING,'F-',1))
	    {
		REMOVE_STRING(RETURN_STRING,'-',1)
		SEND_COMMAND DEV_TP_GRP[nHVAC_ZONE],"'^TXT-',ITOA(FAN_SPEED_TEXT_ADDR),',0,',LEFT_STRING(RETURN_STRING,FIND_STRING(RETURN_STRING,':',1) -1)"
	    }
	    IF(FIND_STRING(RETURN_STRING,'T-',1))	// HANDLED IN LEVEL EVENT
	    {
		REMOVE_STRING(RETURN_STRING,'-',1)
		cITEMP = RETURN_STRING		// TEXT BUTTON UPDATED FROM LEVEL EVENT
	    }
	}
	CLEAR_BUFFER RETURN_STRING
    }
}

LEVEL_EVENT[vdvG50a,HVAC_SETP_LVL]	// SET POINT LEVEL RANGE IS 17 TO 30 CELCIUS DEVICE ONLY RESPONDS IN THIS RANGE ALL FAHRENHEIT VALUES ARE CALCULATED
{
    myHVAC[LEVEL.SOURCEDEV.PORT].SETP = LEVEL.VALUE
    nTEMP_SETPOINT[LEVEL.SOURCEDEV.PORT] = LEVEL.VALUE	// FOR FAHRENHEIT DISPLAY BECAUSE UNIT ONLY COMMUNICATES IN CELSIUS
    IF(bCELCIUS == 0)
    {
	fnTEMP_DISPLAY(nTEMP_SETPOINT[LEVEL.SOURCEDEV.PORT])		// CONVERTS TO FAHRENHEIT BE DEFAULT
    }
    SEND_COMMAND DEV_TP_GRP[LEVEL.SOURCEDEV.PORT],"'^TXT-',ITOA(SET_POINT_TEXT_ADDR),',0,',ITOA(nTEMP_SETPOINT[LEVEL.SOURCEDEV.PORT])"
}

LEVEL_EVENT[vdvG50a,INDOOR_TEMP_LVL]	// INLET TEMP LEVEL DISPLAY
{
    myHVAC[LEVEL.SOURCEDEV.PORT].TEMP = LEVEL.VALUE
    nTMP_INLET[LEVEL.SOURCEDEV.PORT] = LEVEL.VALUE	// FOR FAHRENHEIT DISPLAY BECAUSE UNIT ONLY COMMUNICATES IN CELSIUS
    IF(bCELCIUS == 0)
    {
	fnTEMP_DISPLAY(nTMP_INLET[LEVEL.SOURCEDEV.PORT])		// CONVERTS TO FAHRENHEIT BE DEFAULT
    }
    SEND_COMMAND DEV_TP_GRP[LEVEL.SOURCEDEV.PORT],"'^TXT-',ITOA(CUR_TEMP_TEXT_ADDR),',0,',ITOA(nTMP_INLET[LEVEL.SOURCEDEV.PORT])"
}

TIMELINE_EVENT[TL1]
{
    SEND_COMMAND vdvG50a[1],"'GETDATA-'"	// SENDS REQUEST FOR ALL UNITS
    SEND_COMMAND dvTP,"'^TXT-8,0,UPDATING'"
}

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

// feedback example only buttons flash prior to being set from unit

WAIT 4
nFLASH = !nFLASH

[dvTP,13] = bCELCIUS == 1	// this indicates fahrenheit when set

// FILTER EXAMPLE
[dvTP,210] = ([vdvG50a[GRP_NUM],210] && nFLASH)

[dvTP,220] = (nMODEadj == 1) && nFLASH
[dvTP,231] = (nMODEadj == 2) && nFLASH
[dvTP,214] = (nMODEadj == 3) && nFLASH
[dvTP,221] = (nMODEadj == 4) && nFLASH
[dvTP,219] = (nMODEadj == 5) && nFLASH
[dvTP,244] = (nAIRadj == 1) && nFLASH
[dvTP,245] = (nAIRadj == 2) && nFLASH
[dvTP,246] = (nAIRadj == 3) && nFLASH
[dvTP,247] = (nAIRadj == 4) && nFLASH
[dvTP,248] = (nAIRadj == 5) && nFLASH
[dvTP,240] = (nFANadj == 1) && nFLASH
[dvTP,241] = (nFANadj == 2) && nFLASH
[dvTP,242] = (nFANadj == 3) && nFLASH
[dvTP,243] = (nFANadj == 4) && nFLASH
[dvTP,249] = (nDRVadj == 1) && nFLASH
[dvTP,250] = (nDRVadj == 2) && nFLASH


(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)
